/*
 * Zorin Panel: Various settings and changes for the panel in Zorin Desktop.
 * Copyright (C) 2016 Zorin OS Technologies Ltd.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

const Main = imports.ui.main;
const Lang = imports.lang;

var zorinPanelActivitiesButton = new Lang.Class({
    Name: 'ZorinPanel.ActivitiesButton',

    _init: function(settings) {
        this._zorinPanelSettings = settings;
    },

    enable : function() {
        this._setActivitiesButtonVisible(this._zorinPanelSettings.get_boolean('activities-button'));
        this._bindSettingsChanges();
    },

    disable: function () {
        this._setActivitiesButtonVisible(true);
    },

    _bindSettingsChanges: function() {
        this._zorinPanelSettings.connect('changed::activities-button', Lang.bind(this, function() {
            this._setActivitiesButtonVisible(this._zorinPanelSettings.get_boolean('activities-button'));
        }));
    },

    _setActivitiesButtonVisible: function(isVisible) {
        if(Main.panel.statusArea.activities)
            isVisible ? Main.panel.statusArea.activities.actor.show() :
                Main.panel.statusArea.activities.actor.hide();
    }
});
