/*
 * This file is based on code from the No Topleft Hot Corner extension by
 * HROMANO (as at commit 8cd8c8f7cabe10cb9a92f98f965811fc541f6e15).
 *
 * Licensing information:
 * No Topleft Hot Corner Gnome Shell extension is distributed under the terms
 * of the GNU General Public License, version 2 or later.
 */

const Main = imports.ui.main;
const Lang = imports.lang;

var zorinPanelHotCorner = new Lang.Class({
    Name: 'ZorinPanel.HotCorner',

    _init: function(settings) {
        this._zorinPanelSettings = settings;
    },

    enable : function() {
        this._setHotCorner(this._zorinPanelSettings.get_boolean('activities-hot-corner'));
        this._bindSettingsChanges();
    },

    disable: function () {
        this._setHotCorner(true);
    },

    _bindSettingsChanges: function() {
        this._zorinPanelSettings.connect('changed::activities-hot-corner', Lang.bind(this, function() {
            this._setHotCorner(this._zorinPanelSettings.get_boolean('activities-hot-corner'));
        }));
    },

    _setHotCorner: function(isEnabled) {
        if(!isEnabled) {
            Main.layoutManager.hotCorners.forEach(function(hot_corner) {
                if (!hot_corner)
                    return;

                hot_corner._toggleOverview = function() {};
                hot_corner._pressureBarrier._trigger = function() {};
            });

            this._hotCornerId = Main.layoutManager.connect('hot-corners-changed', Lang.bind(this, function () {
                this._setHotCorner(false);
            }));
        } else {
            if(this._hotCornerId) {
                Main.layoutManager.disconnect(this._hotCornerId);   
                this._hotCornerId = null;
            }
            Main.layoutManager._updateHotCorners();
        }   
    }
});

